<?php

namespace App\AdminModule\Presenters;

abstract class SecuredPresenter extends AdminBasePresenter
{

	protected function startup()
	{
		parent::startup();

		if (!$this->user->loggedIn) {
			//automaticky odhlaseni pri neaktivitě
			if ($this->user->getLogoutReason() === \Nette\Security\IUserStorage::INACTIVITY) {
				$this->flashMessage('Pro delší neaktivitu jste byli odhlášeni. Prosím, přihlaste se znovu.', 'alert-info');
			}
			$this->redirect('Sign:in', array('backlink' => $this->storeRequest()));
			$this->terminate();
		}
	}
}