<?php

namespace App\AdminModule\Presenters;

use Nette\Application\UI\Form,
	Nette\Security\AuthenticationException;

class SignPresenter extends AdminBasePresenter
{


	public function actionDefault()
	{
		$this->redirect('in');
	}


	public function actionIn()
	{
		if ($this->user->loggedIn) {
			$this->redirect('Homepage:');
		}
	}


	public function actionOut()
	{
		$this->user->logout();
		$this->flashMessage('Byli jste úspěšně odhlášeni.', 'alert-success');
		$this->redirect('in');
	}


	protected function createComponentSignInForm()
	{
		$form = new Form;
		$form->addText('username', 'Přihlašovací jméno')
			->setAttribute('placeholder', 'Přihlašovací jméno')
			->setRequired('Přihlašovací jméno je povinné');
		$form->addPassword('password', 'Heslo')
			->setAttribute('placeholder', 'Heslo')
			->setRequired('Heslo je povinné');
		$form->addCheckbox('remember', 'Zapamatovat si mě?');
		$form->addSubmit('submit', 'Přihlásit');
		$form->onSuccess[] = callback($this, 'SignInFormSucceded');
		return $form;
	}


	public function SignInFormSucceded(Form $form)
	{
		$values = $form->getValues();
		try {
			$this->user->login($values->username, $values->password);
		} catch (AuthenticationException $e) {
			$this->flashMessage($e->getMessage(), 'alert-danger');
			return;
		}
		$values->remember ? $this->user->setExpiration('+14 days', FALSE) : $this->user->setExpiration('+20 minutes', TRUE);
		$this->redirect('Homepage:');
	}

}
