<?php

namespace App\Model;

use Nette\Utils\DateTime;

class MenuModel extends BaseModel
{

	public function getPossibleParents($menuRow)
	{

		if (isset($menuRow)) {
			return $this->findBy(['lvl' => [1,
						2],
					'NOT id' => $menuRow->id]);
		} else {
			return $this->findBy(['lvl' => [1,
						2]]);
		}
	}


	public function addItem($values)
	{

		if ($values->menu_id === NULL) {
			$values->lvl = 1;
		} else {
			$menuRow = $this->findById($values->menu_id);
			if ($menuRow->menu_id === NULL) {
				$values->lvl = 2;
			} else {
				$values->lvl = 3;
			}
		}

		$values->created = new DateTime;

		$menuRow = $this->findBy(['menu_id' => $values->menu_id])->order('order DESC')->limit(1)->fetch();

		if ($menuRow) {
			$values->order = $menuRow->order + 1;
		}

		// SELECT * FROM menu WHERE menu_id = values->menu_id ORDER BY order desc LIMIT 1

		$this->add($values);
	}


	public function updateItem($menuRow, $values)
	{

		if ($values->menu_id === NULL) {
			$values->lvl = 1;
		} else {
			$mRow = $this->findById($values->menu_id);
			if ($mRow->menu_id === NULL) {
				$values->lvl = 2;
			} else {
				$values->lvl = 3;
			}
		}

		// změna rodiče zmení změní order
		if ($menuRow->menu_id !== $values->menu_id) {
			$mRow = $this->findBy(['menu_id' => $values->menu_id])->order('order DESC')->limit(1)->fetch();
			if ($mRow) {
				$values->order = $mRow->order + 1;
			}
		}

		$menuRow->update($values);
	}


	public function moveItemUp($id)
	{

		$menuRow = $this->findById($id);

		$prevMenuRow = $this->findBy(['menu_id' => $menuRow->menu_id, 'order <' => $menuRow->order])->order('order DESC')->limit(1)->fetch();


		if ($prevMenuRow) {

			$order = $menuRow->order;
			$menuRow->update(['order' => $prevMenuRow->order]);
			$prevMenuRow->update(['order' => $order]);
		}
	}


	public function moveItemDown($id)
	{

		$menuRow = $this->findById($id);

		$nextMenuRow = $this->findBy(['menu_id' => $menuRow->menu_id, 'order >' => $menuRow->order])->order('order ASC')->limit(1)->fetch();


		if ($nextMenuRow) {

			$order = $menuRow->order;
			$menuRow->update(['order' => $nextMenuRow->order]);
			$nextMenuRow->update(['order' => $order]);
		}
	}

	public function setHomepage($id)
	{
		$this->findBy(['hp' => TRUE])->update(['hp' => FALSE]);

		$menuRow = $this->findById($id);

		if($menuRow->lvl === 1) {
			$menuRow->update(['hp' => TRUE]);
		} 

	}

	public function toggleVisibility($id)
	{
		$row = $this->findById($id);
		$row->update(['visible' => !$row->visible]);
		
		$childs = $this->findBy(['menu_id' => $row->id]);
		
		if($childs) {
			
			foreach ($childs as $child) {
				$child->update(['visible' => $row->visible]);
				$grandchilds = $this->findBy(['menu_id' => $child->id]);
				
				foreach ($grandchilds as $grandchild) {
					$grandchild->update(['visible' => $row->visible]);
				}
			}
		}
		
		return $row;
	}
	
}
