<?php

namespace App\Nette;

use Nette\Security;

class User extends Security\User
{

	/** @var App\Model\UserModel */
	protected $userModel;

	/** @var Nette\Database\Table\ActiveRow */
	private $row;


	public function __construct(Security\IUserStorage $storage, \App\Model\UserModel $userModel, Security\IAuthenticator $authenticator = NULL, Security\IAuthorizator $authorizator = NULL)
	{
		parent::__construct($storage, $authenticator, $authorizator);
		$this->userModel = $userModel;
		
		if ($this->isLoggedIn()) {
			$this->getRow(); //check invalidate
		}
	}


	public function getRow()
	{
		if ($this->row === NULL) {
			$this->row = $this->userModel->get($this->getId());
			if ($this->row === FALSE || $this->row->deleted !== NULL) {
				$this->logout(TRUE);
			} elseif (($this->row->invalidate != $this->getIdentity()->invalidate)) { //invalidate
				$this->getStorage()->setIdentity(\App\Model\UserManager::createIdentity($this->row));
			}
		}
		return $this->row;
	}

}
